
final class Tempo {  // NB: la classe non puo' essere estesa

	private int ore = 1;
	private int minuti = 1;
	private int secondi = 1;
	static char separatore = '-';
	
	public int assegnaTempo(int ora,int min,int sec){
		if (ora>=0 && ora<24 && min>=0&& min<60 && sec>=0 && sec<60) {
			ore=ora; minuti=min; secondi=sec; 
			return 0;
		} else return -1;
	}

	//inizializzatore statico: viene eseguito una sola volta al caricamento della classe
	static { 
		System.out.println("Caricamento della classe Tempo... ");
		System.out.println("Separatore iniziale: " + separatore);
	}

	//inizializzatore d'istanza: viene eseguito quando si istanzia un oggetto della classe
	//dopo un'eventuale inizializzazione esplicita dei campi
	//prima del metodo costruttore
	//dopo un eventuale inizializzatore statico
	//NB: in un inizializzatore distanza  impossibile passare parametri, come si potrebbe eventualmente fare in un costruttore
	{
		System.out.print("Nuova istanza: "); 
		ore=minuti=secondi=0;  //inizializzazione
	}
	

public int getOre(){ return ore; }
public int getMinuti(){ return minuti; }
public int getSecondi(){ return secondi; }

public void aggiungiOre (int numOre){
		ore+=numOre;
		while (ore>23) ore-=24;
	}

public void visualizza (boolean ritornoACapo){
		System.out.print(ore);
		System.out.print(separatore);
		System.out.print(minuti);
		System.out.print(separatore);
		if (ritornoACapo) System.out.println(secondi);
		else System.out.print(secondi);
 	}

} //end-classe Tempo1
