
// Esercitazione ereditariet

class Tempo {  // NB: la superclasse non puo' essere final

	protected int ore = 0;
	//modificatore protected necessario solo se si vuole consentire accesso diretto
	//al campo da parte della sottoclasse 
	protected int minuti = 0;
	protected int secondi = 0;
	static char separatore = ':';
	
	public int assegnaTempo(int ora,int min,int sec){
		if (ora>=0 && ora<24 && min>=0&& min<60 && sec>=0 && sec<60) {
			ore=ora; minuti=min; secondi=sec; 
			return 0;
		} else return -1;
	}

	public int getOre(){ return ore; }
	public int getMinuti(){ return minuti; }
	public int getSecondi(){ return secondi; }

	public void aggiungiOre (int numOre){
		ore+=numOre;
		while (ore>23) ore-=24;
	}

public void visualizza (boolean ritornoACapo){
		System.out.print(ore);
		System.out.print(separatore);
		System.out.print(minuti);
		System.out.print(separatore);
		if (ritornoACapo) System.out.println(secondi);
		else System.out.print(secondi);
 	}

} //end-classe Tempo


class Tempo2 extends Tempo {
	private int centesimi = 0;


	public int assegnaTempo(int ora,int min,int sec, int cent){
		if (ora>=0 && ora<24 && min>=0&& min<60 && sec>=0 && sec<60 && cent>=0 && cent<60) {
			ore=ora; minuti=min; secondi=sec; 
			centesimi=cent;
			return 0;
		} else return -1;
	}

  	public void assegnaCentesimi(int cent){
		this.centesimi = cent ;
  	}

	public int getCentesimi() {
		return centesimi ;
	}

	public void visualizza (boolean ritornoACapo){
		System.out.print(ore);
		System.out.print(separatore);
		System.out.print(minuti);
		System.out.print(separatore);
		System.out.print(secondi);
		System.out.print(separatore);
		if (ritornoACapo) System.out.println(centesimi);
		else System.out.print(centesimi);
 	}

/***** NB: esempio di codice alternativo: non richiede campi "protected"
	public int assegnaTempo(int ora, int min, int sec, int cent){
		int esitoTempo = super.assegnaTempo(ora,min,sec);
		if (esitoTempo == 0 && cent<60) {
			centesimi=cent;
			return 0;
		}
		else return -1;
	}

******/

} //end-classe Tempo2
